﻿class QuestionsMC extends GamePiece{
	
	
	//************************************************************
	//PRIVATE VARS
	//************************************************************
	
	
	private var QuestionTitlesMC:MovieClip;
	
	private var btnOverlayMCT:MovieClip;
	private var btnOverlayMCF:MovieClip;
	
	private var btnContinueMC:MovieClip;
	
	private var tb_questionBox:TextField;
	private var tb_answerBox:TextField;
	
	private var questionsArray:Array;
	private var questionCount:Number;
	
	private var b_true:Button;
	private var b_false:Button;
	
	private var poseQuestionSound:Sound;
	private var correctResponseSound:Sound;
	private var inCorrectResponseSound:Sound;
	
	
	//************************************************************
	//PROPERTIES
	//************************************************************
	private var _questionsLoaded:Boolean;
	public function get QuestionsLoaded():Boolean{
		
		return this._questionsLoaded;
		
	}
	
	public function set QuestionsLoaded(val:Boolean){
		
		this._questionsLoaded = val;
		
	}
	
	
	



	//************************************************************
	//CONSTRUCTOR FUNCTIONS
	//************************************************************

	public function QuestionsMC(){
		
		trace("QuestionsMC Created");
		makeThisADispatcher();
		loadQuestions();
		
		poseQuestionSound = new Sound(this);
		poseQuestionSound.attachSound("p2p_question.wav");
		
		correctResponseSound = new Sound(this);
		correctResponseSound.attachSound("p2p_correct.wav");
		
		inCorrectResponseSound = new Sound(this);
		inCorrectResponseSound.attachSound("p2p_incorrect.wav");
	
		
	}
	
	
	
	//************************************************************
	//VISUAL FUNCTIONS
	//************************************************************
	
	private function visual_fadeQuestionTitle(){
		
		QuestionTitlesMC._alpha = 100;
		QuestionTitlesMC.tween("_alpha",0,1,"customEasing", 2.5);
		
	}
	
	private function visual_clearAllButtons(){
		
		btnOverlayMCT.gotoAndStop("off");
		btnOverlayMCF.gotoAndStop("off");
		
	}
	
		private function visual_clearAllContinueButton(){
		
		btnContinueMC.gotoAndStop("off");
		
	}
	
	
	//************************************************************
	//INITIAL FUNCTIONS
	//************************************************************
	
	public function restartQuestions(){
		
		trace("init questions");
		questionCount = 0;
		
	}
	
	//************************************************************
	//PUBLIC GENERAL FUNCTIONS
	//************************************************************
		
		public function enableTFButtons(){
			
			b_false.enabled = true;
			b_true.enabled = true;
			
		}
		
		
		
		public function disableTFButtons(){
			
			b_false.enabled = false;
			b_true.enabled = false;
			
		}
		
		
		public function loadQuestions(){
		
		//choose the correct textfile to load.
		var textFileName:String;
		textFileName = "P2PQuestions.txt";
	
		
		
		var my_lv:LoadVars = new LoadVars();
		my_lv.onLoad = function(success:Boolean) {
		if (success) {
		
			//trace(this)
			eval(this.myQuestionsMC).QuestionsLoaded = true
			eval(this.myQuestionsMC).populateQuestions(this);
		  
		  } else {
			trace("Error loading/parsing LoadVars.");
		  }
		};
		
		my_lv.myQuestionsMC = this;
		my_lv.load(textFileName);
		
	}
	
	
	
	//Q = question, A = Answer, IR = Incorrect Response
	public function populateQuestions(loadvarsObj:Object){
		
		//trace("popuplate = " + loadvarsObj);
		questionsArray = new Array();
		var question:Object;
		
		var convert:String
		var conversionArray:Array = new Array;
		conversionArray[0] = "a";
		conversionArray[1] = "b";
		conversionArray[2] = "c";
		conversionArray[3] = "d";
		conversionArray[4] = "e";
		conversionArray[5] = "f";
		conversionArray[6] = "g";
		conversionArray[7] = "h";
		conversionArray[8] = "i";
		
		for(var x = 0; x < 9; x++){
			
			question = new Object();
			convert = conversionArray[x];
			
			question.Q = loadvarsObj["Q" + convert];
			question.A = loadvarsObj["Q" + convert + "A"];
			question.IR = loadvarsObj["Q" + convert + "IR"];

			questionsArray.push(question);
			
		}
		
		questionsArray = scrambleArray(questionsArray);
		
	}
	
	
	public function poseQuestion(){
		
		visual_clearAllButtons();
		enableTFButtons();
			
		tb_questionBox.text= questionsArray[questionCount].Q;
		 tb_answerBox.text = "";
		//trace("Q+ " + questionsArray[questionCount].Q)
		trace("Question textbox = " + tb_questionBox.bottomScroll);
		
		//cheap verticle position system for question textbox
		switch(tb_questionBox.bottomScroll){
			
			case 2:
			tb_questionBox._y = 35;
			break;
			
			case 3:
			tb_questionBox._y = 25;
			break;
			
			case 4:
			tb_questionBox._y = 15;
			break;
			
			case 5:
			tb_questionBox._y = 5;
			break;
			
		}
		
		QuestionTitlesMC.gotoAndStop("f" + (questionCount + 1));
		visual_fadeQuestionTitle();
		
		//delay the sound start a sec
		//pause for a sec
		var pauseCodeExec:Function = function(thisMC){
			
			//play the loosing ani then the final score screen
			thisMC.poseQuestionSound.start();
			
		}
		
		pauseCodeAndCallFunction(1500, pauseCodeExec);
		
	}
	

	
	
	//************************************************************
	//PRIVATE GENERAL FUNCTIONS
	//************************************************************
	
	private function checkResponse(userResponse:String, btn:MovieClip){
		
		trace("A = " + questionsArray[questionCount].A);
		if(userResponse == questionsArray[questionCount].A){
			
			btnContinueMC.gotoAndStop("userTurn");
			
			btn.gotoAndStop("true");
			correctResponseSound.start();
			
		}else{
			
			btnContinueMC.gotoAndStop("computerTurn");
			btn.gotoAndStop("false");
			tb_answerBox.text = questionsArray[questionCount].IR;
			inCorrectResponseSound.start();
			
		}
		
		questionCount++;
		
	}

	
	
	//************************************************************
	//HELPER FUNCTIONS
	//************************************************************
	
		//shuffles the question array
	private function scrambleArray(arrayToScramble)
	{
		
		var tempArray = arrayToScramble;
		var arraySize:Number = tempArray.length;
		var numberShuffle:Number = random(15) + 5;

		for (var x = 1; x <= numberShuffle; x++) {
		  for (var y = 0; y < arraySize; y++) {
			var temp = random(arraySize);
			var temp2 = tempArray[y];
			tempArray[y] = tempArray[temp];
			tempArray[temp] = temp2;
		  }
		}
		
		return tempArray;
	}
	
	
	
	//************************************************************
	//EVENT FUNCTIONS
	//************************************************************
	
	private function falseButtonClicked(){
		
		//trace("False btn clicked");
		checkResponse("F", btnOverlayMCF);
		disableTFButtons();
		
	}
	
	
	private function trueButtonClicked(){
		
		//trace("True btn clicked");
		checkResponse("T", btnOverlayMCT);
		disableTFButtons();
		
	}
	
	
	private function continueWithUserMoveClicked(){
		
		//trace("continueWithUserMoveClicked()");
		visual_clearAllContinueButton();
		//call on super
		dispatchMyEvent("clickToContinue", {myMessage:"userMove"});
		
	}
	
	
	private function continueWithComputerMoveClicked(){
		
		//trace("continueWithComputerMoveClicked()");
		
		visual_clearAllContinueButton();
		//call on super
		dispatchMyEvent("clickToContinue", {myMessage:"computerMove"});
		
	}
	
	
	
	

	//************************************************************
	//CUSTOM EVENT FUNCTIONS
	//************************************************************
	
	
	
	
	
	
	
}